* initial checkin
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Don Okt 12 13:00:04 CEST 2006 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 CMDLINE="$(cat /proc/cmdline)"
93 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
94 # }}}
95
96 # {{{ Check if we are running from the grml-CD or HD
97 INSTALLED=""
98 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
99
100 # testcd
101 TESTCD=""
102 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
103 # }}}
104
105 # {{{ source lsb-functions , color handling
106 if checkbootparam "nocolor"; then
107   RC_NOCOLOR=yes
108   . /etc/grml/lsb-functions
109   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
110 else
111   . /etc/grml/lsb-functions
112   . /etc/grml_colors
113 fi
114 # }}}
115
116 # {{{ debug
117 config_debug(){
118  if checkbootparam "debug"; then
119    BOOTDEBUG="yes"
120  fi
121  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
122    BOOTDEBUG="yes"
123  fi
124  rundebugshell(){
125   if [ -n "$BOOTDEBUG" ]; then
126     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
127     eindent
128     if [ -r /etc/grml/screenrc ] ; then
129        einfo "Starting GNU screen to be able to use a full featured shell environment."
130        einfo "Just exit the shells (and therefore screen) to continue boot process..."
131        /bin/zsh -c "screen -c /etc/grml/screenrc"
132     else
133       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
134       einfo "Just exit the shell to continue boot process..."
135       /bin/zsh
136     fi
137     eoutdent
138   fi
139  }
140 }
141 # }}}
142
143 # {{{ log
144 config_log(){
145 if checkbootparam "log"; then
146   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
147   touch $DEBUG
148   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
149   eindent
150     einfo "Starting bootlogd."
151     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
152   eoutdent
153 else
154   DEBUG="/dev/null"
155 fi
156 }
157 # }}}
158
159 # {{{ Check if we are in interactive startup mode
160 INTERACTIVE=""
161 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
162 # }}}
163
164 # {{{ set firmware timeout via bootparam
165 config_fwtimeout(){
166  if checkbootparam fwtimeout ; then
167    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
168    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
169    rmmod firmware_class 1>>$DEBUG 2>&1
170    modprobe firmware_class ; eend $?
171  fi
172  if [ -z "$TIMEOUT" ] ; then
173    TIMEOUT="100" # linux kernel default: 10
174  fi
175  if [ -f /sys/class/firmware/timeout ] ; then
176    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
177    echo 100 > /sys/class/firmware/timeout ; eend $?
178  fi
179 }
180 # }}}
181
182 ### {{{ language configuration / localization
183 config_language(){
184
185  einfo "Activating language settings:"
186  eindent
187
188  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
189  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
190
191  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
192
193  # check for bootoption which overrides config from /etc/grml/autoconfig:
194  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
195  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
196
197  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
198  if [ -z "$INSTALLED" ] ; then
199     [ -n "$LANGUAGE" ] || LANGUAGE='en'
200  fi
201
202  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
203  if [ -n "$BOOT_LANGUAGE" ] ; then
204     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
205  fi
206
207  # set console font
208  if [ -z "$CONSOLEFONT" ] ; then
209     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
210        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
211        if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
212           CONSOLEFONT='Lat15-Terminus16'
213        else
214           ewarn "/usr/share/consolefonts/Lat15-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
215        fi
216     fi
217  fi
218
219  # export it now, so error messages get translated, too
220  if checkgrmlsmall ; then
221     export LANG='C' # grml-small does not provide any further locales
222  else
223     [ -r /etc/default/locale ] && . /etc/default/locale
224     export LANG LANGUAGE
225  fi
226
227  # configure keyboard layout, read in already set values first:
228  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
229
230  # now allow keyboard override by boot commandline for later use:
231  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
232  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
233  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
234  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
235  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
236
237  # modify /etc/sysconfig/keyboard only in live-cd mode:
238  if [ -z "$INSTALLED" ] ; then
239
240    local LANGUAGE="$BOOT_LANGUAGE"
241    . /etc/grml/language-functions
242    # allow setting xkeyboard explicitly different than console keyboard
243    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
244    if [ -n "$KXKEYBOARD" ]; then
245       XKEYBOARD="$KXKEYBOARD"
246       KDEKEYBOARD="$KXKEYBOARD"
247    elif [ -n "$KKEYBOARD" ]; then
248       XKEYBOARD="$KKEYBOARD"
249       KDEKEYBOARD="$KKEYBOARD"
250    fi
251
252    # duplicate of previous code to make sure /etc/grml/language-functions
253    # does not overwrite our values....
254    # now allow keyboard override by boot commandline for later use:
255    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
256    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
257    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
258    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
259    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
260
261    # write keyboard related variables to file for later use
262    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
263    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
264    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
265    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
266  fi
267
268  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
269
270   # Set default keyboard before interactive setup
271   if [ -n "$KEYTABLE" ] ; then
272    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
273    loadkeys -q $KEYTABLE &
274    eend $?
275   fi
276
277   if [ -n "$CONSOLEFONT" ] ; then
278      einfo "Running consolechars using ${CONSOLEFONT}"
279      consolechars -f $CONSOLEFONT || consolechars -d
280      eend $?
281
282      if [ -n "$UTF8" ] ; then
283         einfo "Notice: run 'filterm - dynafont' in your shell to enable a unicode capable console."
284      fi
285   fi
286
287   # we have to set up all consoles, therefore loop it over all ttys:
288   if [ -n "$CHARMAP" ] ; then
289    einfo "Running consolechars for ${CHARMAP}"
290    NUM_CONSOLES=`fgconsole --next-available`
291    NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
292    [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
293    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
294      consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
295    done
296    eend ${RC}
297   fi
298
299  eoutdent
300 }
301 # }}}
302
303 # {{{ Set hostname
304 config_hostname(){
305  if checkbootparam hostname ; then
306   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
307   einfo "Setting hostname to $HOSTNAME as requested."
308   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
309   hostname $HOSTNAME ; eend $?
310  else
311   hostname --file /etc/hostname
312  fi
313 }
314 # }}}
315
316 # fstabuser (needed when running from harddisk with username != grml {{{
317 config_userfstab(){
318   fstabuser=$(getent passwd 1000 | cut -d: -f1)
319   [ -n "$fstabuser" ] || fstabuser='grml'
320 }
321 # }}}
322
323 # {{{ Set clock (Local time is more often used than GMT, so it is default)
324 config_time(){
325  # don't touch the files if running from harddisk:
326  if [ -z "$INSTALLED" ]; then
327   UTC=""
328   checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
329   checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
330   # hwclock uses the TZ variable
331   export TZ
332   hwclock $UTC -s
333  fi
334 }
335 # }}}
336
337 # {{{ print kernel info
338 config_kernel(){
339   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
340   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
341 }
342 # }}}
343
344 # {{{ vmware specific stuff
345 config_vmware(){
346 if checkbootparam novmware ; then
347  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
348 else
349  if [ -z "$INSTALLED" ]; then
350   if vmware-detect ; then
351     if [ -r /etc/X11/xorg.conf.vmware ] ; then
352       einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
353       cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
354     fi
355   fi
356  fi
357 fi
358 }
359 # }}}
360
361 # {{{ installed on hd?
362 config_checkfs(){
363 if [ -n "$INSTALLED" ]; then
364   einfo "Running from HD, checking filesystems."
365 # We are running from HD, so a file system check is recommended
366   [ -f /etc/init.d/checkroot.sh ] && /etc/init.d/checkroot.sh
367   [ -f /etc/init.d/checkfs.sh ]   && /etc/init.d/checkfs.sh
368   eend 0
369 fi
370 }
371 # }}}
372
373 # {{{ / must be read-write in any case, starting from here
374 config_remount_root(){
375   mount -o remount,rw / 2>>$DEBUG
376 }
377 # }}}
378
379 # {{{ ld.so.cache + depmod
380 config_ld_mod(){
381 if [ -n "$INSTALLED" ]; then
382  if ! [ -r /etc/grml.first.boot ] ; then
383   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
384   eindent
385 # Regenerate ld.so.cache and module dependencies on HD
386     einfo "Running ldconfig" ; ldconfig  ; eend $?
387     einfo "Running depmod"   ; depmod -a ; eend $?
388     touch /etc/grml.first.boot
389     eend 0
390   eoutdent
391  fi
392 fi
393 }
394 # }}}
395
396 # update_progress {{{
397 update_progress(){
398   # be sure we are non-blocking
399   (echo "$1" > /etc/sysconfig/progress) &
400 }
401 # }}}
402
403 # {{{ timezone
404 config_timezone(){
405  # don't touch the files if running from harddisk:
406  if [ -z "$INSTALLED" ]; then
407   einfo "Setting timezone."
408   KTZ="$(getbootparam tz 2>>$DEBUG)"
409   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
410   rm -f /etc/localtime
411   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
412  fi
413 }
414 # }}}
415
416 # small computer / nearly no ram {{{
417 config_small(){
418
419 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
420 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
421 eindent
422
423 if checkbootparam "small"; then
424   einfo "Information: ${RAM} kB of RAM available." ; eend 0
425   einfo "Bootoption small detected. Activating small system."
426   if [ -r /etc/inittab.small ] ; then
427     mv /etc/inittab /etc/inittab.normal
428     mv /etc/inittab.small /etc/inittab
429   else
430     sed -i 's/^9/#&/' /etc/inittab
431     sed -i 's/^10/#&/' /etc/inittab
432     sed -i 's/^11/#&/' /etc/inittab
433     sed -i 's/^12/#&/' /etc/inittab
434   fi
435   /sbin/telinit q ; eend $?
436 else
437   if checkgrmlsmall ; then
438     if [[ $RAM -lt 25000 ]] ; then
439       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
440       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
441       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
442       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
443       /bin/zsh --login
444     else
445       einfo "Information: ${RAM} kB of RAM available." ; eend 0
446     fi
447   else
448     if [[ $RAM -lt 58000 ]] ; then
449       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
450       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
451       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
452       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
453       /bin/zsh --login
454     else
455       einfo "Information: ${RAM} kB of RAM available." ; eend 0
456     fi
457   fi
458 fi
459 eoutdent
460 }
461 # }}}
462
463 # skip startup of w3m {{{
464 config_fast(){
465 if checkbootparam "fast"; then
466   ewarn "Bootoption fast detected. Skipping startup of w3m."
467     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
468   /sbin/telinit q ; eend $?
469 fi
470 }
471 # }}}
472
473 # activate serial console {{{
474 config_console(){
475 if checkbootparam "console"; then
476   einfo "Bootoption (for serial) console detected. Activating mgetty."
477     sed -i 's/^#T0/T0/' /etc/inittab
478     sed -i 's/^#T1/T1/' /etc/inittab
479   /sbin/telinit q ; eend $?
480 fi
481 }
482 # }}}
483
484 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
485 config_cdrom_perm(){
486 CDROMS=""
487 for DEVICE in /proc/ide/hd?; do
488  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
489 done
490 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
491 }
492 # }}}
493
494 # {{{ Bring up loopback interface now
495 config_local_net(){
496  if [ -z "$INSTALLED" ] ; then
497     grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
498  fi
499 }
500 # }}}
501
502 # firewire devices {{{
503 # the raw1394 driver does not yet export info into SYSFS,
504 # so let's create raw1394 device manually
505 # http://www.michael-prokop.at/blog/index.php?p=352
506 config_firewire_dev(){
507 if checkbootparam "nofirewiredev" ; then
508   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
509 else
510 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
511   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
512 #  cd /dev && MAKEDEV video1394 raw1394
513   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
514   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
515 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
516   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
517   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
518   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
519 fi
520 #fi
521 }
522 # }}}
523
524 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
525 # otherwise we will get: passwd: Authentication token lock busy
526 config_fix_passwd(){
527  if [ -z "$INSTALLED" ] ; then
528   touch /etc/.pwd.lock
529  fi
530 }
531 # }}}
532
533 # {{{ CD Checker
534 config_testcd(){
535 if [ -n "$TESTCD" ]; then
536   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
537   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
538   echo -n "${RED}"
539   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
540   if [ "$?" = "0" ]; then
541     echo " ${GREEN}Everything looks OK${NORMAL}"
542     else
543     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
544     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
545     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
546     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
547     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
548     read a
549   fi
550   eend 0
551 fi
552 }
553 # }}}
554
555 # {{{ hardware detection via discover
556 config_discover(){
557 if checkbootparam "nodisc" ; then
558   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
559 else
560  if [ -x /sbin/discover ] ; then
561   einfo "Discovering hardware. Trying to load the following modules in background:"
562    eindent
563    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
564    eoutdent
565   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
566   eend 0
567  else
568   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
569  fi
570 fi
571 }
572 # }}}
573
574 # {{{ hardware detection via hwinfo
575 config_hwinfo(){
576 if checkbootparam hwinfo >>$DEBUG 2>&1; then
577   einfo "Discovering hardware via hwinfo:"
578   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
579   echo -n "  Loading modules: "
580   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
581   eend 0
582 fi
583 }
584 # }}}
585
586 # {{{ disable hotplug agents on request
587 config_hotplug_agent(){
588 if checkbootparam "noagent" ; then
589   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
590   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
591   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
592   einfo "Disabling hotplug-agent(s) $AGENTNL"
593   for agent in $(echo -e $AGENTLIST) ; do
594     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
595   done
596   [ "$?" == "0" ] ; eend $?
597 fi
598 }
599 # }}}
600
601 # {{{ blacklist of hotplug-modules
602 config_hotplug_blacklist(){
603 if checkbootparam "black" ; then
604   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
605   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
606   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
607   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
608   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
609   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
610   eend 0
611 fi
612 }
613 # }}}
614
615 # {{{ run hotplug
616 config_hotplug(){
617 if checkbootparam "nohotplug" ; then
618   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
619 else
620   if [ -r /etc/init.d/hotplug ] ; then
621     einfo "Starting hotplug system in background."
622     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
623     eend 0
624   elif [ -r /etc/init.d/hotplug-light ] ; then
625     einfo "Starting hotplug-light system in background."
626     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
627     eend 0
628   else
629     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
630   fi
631 fi
632 }
633 # }}}
634
635 # {{{ blacklist specific module
636 config_blacklist(){
637 if checkbootparam "blacklist" ; then
638  if [ -z "$INSTALLED" ]; then
639   einfo "Bootoption blacklist found."
640   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
641   if [ -n "$BLACK" ] ; then
642     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
643     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
644     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
645     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
646     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
647   else
648    eerror "No given module for blacklist found. Blacklisting will not work therefor."
649   fi
650  else
651   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
652   eindent
653    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
654   eoutdent
655  fi
656 fi
657 }
658 # }}}
659
660 # {{{ ACPI
661 config_acpi_apm(){
662 if [ -d /proc/acpi ]; then
663   if checkbootparam "noacpi"; then
664     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
665   else
666     einfo "ACPI Bios found, activating modules: "
667     eindent
668     found=""
669     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
670       basename="${a##*/}"
671       basename="${basename%%.*}"
672       case "$basename" in *_acpi)
673        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
674       esac
675       modprobe $basename >>$DEBUG 2>&1 && found="yes"
676       local BASE="$BASE $basename"
677     done
678     if [ -n "$found" ] ; then
679       einfo "$BASE"  ; eend 0
680     else
681       ewarn "(none)" ; eend 1
682     fi
683     if ! [ -S /var/run/acpid.socket ] ; then
684       if ! [ -r /var/run/dbus/pid ] ; then
685         einfo "Starting acpi daemon."
686         /etc/init.d/acpid start >>$DEBUG ; eend $?
687       else
688         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
689         eerror "Solution: please activate acpid via /etc/runlevel.conf"
690         eend 1
691       fi
692     else
693       ewarn "acpi daemon already running."
694       eend 0
695     fi
696     eoutdent
697   fi
698 else
699 # APM
700   if checkbootparam "noapm"; then
701     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
702   else
703     modprobe apm power_off=1 >>$DEBUG 2>&1
704     if [ "$?" = "0" ] ; then
705        if [ -x /etc/init.d/apmd ] ;then
706           einfo "APM Bios found, enabling power management functions."
707           /etc/init.d/apmd start ; eend $?
708        fi
709     else
710       eerror "Loading apm module failed." ; eend 1
711     fi
712   fi
713 fi
714 }
715 # }}}
716
717 # {{{ PCMCIA Check/Setup
718 # This needs to be done before other modules are being loaded (by hwsetup)
719 config_pcmcia(){
720 if checkbootparam "nopcmcia"; then
721   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
722 else
723   if /usr/sbin/laptop-detect ; then
724     einfo "Detected Laptop - checking for PCMCIA." && eend 0
725     modprobe pcmcia_core >>$DEBUG 2>&1
726     # Try Cardbus or normal PCMCIA socket drivers
727     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
728     if [ "$?" = "0" ]; then
729       modprobe ds >>$DEBUG 2>&1
730       if [ -d /proc/bus/pccard ] ; then
731        if [ -x /sbin/cardmgr ] ; then
732         einfo "PCMCIA found, starting cardmgr."
733         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
734        else
735         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
736        fi
737       fi
738     fi
739   fi
740 fi
741 }
742 # }}}
743
744 # {{{ run software synthesizer via speakup
745 config_swspeak(){
746 if checkbootparam swspeak ; then
747  if [ -d /proc/speakup/ ] ; then
748   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
749   eindent
750    if [ -x /etc/init.d/speech-dispatcher ] ; then
751      einfo "Starting speech-dispatcher."
752      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
753      einfo "Activating sftsyn in Kernel."
754      echo sftsyn >/proc/speakup/synth_name ; eend $?
755      einfo "Just run swspeak if you want to use software synthesizer via speakup."
756      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
757    else
758     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
759     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
760    fi
761   eoutdent
762  else
763   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
764   flite -o play -t "Kernel does not seem to support speakup. Sorry."
765  fi
766 fi
767 }
768 # }}}
769
770 # {{{ Check for blind option or brltty
771 config_blind(){
772 BLIND=""
773 checkbootparam "blind" && BLIND="yes"
774 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
775
776 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
777   if [ -x /sbin/brltty ]; then
778     # Blind option detected, start brltty now.
779     # modprobe serial_core parport_serial generic_serial && echo "done"
780     CMD=brltty
781     BRLTYPE=""
782     BRLDEV=""
783     BRLTEXT=""
784     if [ -n "$BRLTTY" ]; then
785       # Extra options
786       BRLTYPE="${BRLTTY%%,*}"
787       R="${BRLTTY#*,}"
788       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
789         BRLTTY="$R"
790         BRLDEV="${BRLTTY%%,*}"
791         R="${BRLTTY#*,}"
792         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
793           BRLTTY="$R"
794           BRLTEXT="${BRLTTY%%,*}"
795           R="${BRLTTY#*,}"
796         fi
797       fi
798     fi
799     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
800     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
801     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
802     einfo "Starting braille-display manager."
803 #    ( exec $CMD & )
804     ( sh -c "$CMD" & )
805     sleep 2 && BLINDSOUND="yes"
806     eend 0
807   fi
808 fi
809 }
810 # }}}
811
812 # {{{ Interactive configuration
813 config_interactive(){
814 if [ -n "$INTERACTIVE" ] ; then
815 einfo "Entering interactive configuration second stage."
816
817   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
818   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
819   read a
820   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
821
822   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
823   read a
824   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
825
826   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
827   read a
828   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
829   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
830 fi
831 eend 0
832 }
833 # }}}
834
835 # {{{ AGP
836 config_agp(){
837 if checkbootparam forceagp ; then
838 # Probe for AGP. Hope this can fail safely
839   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
840 fi
841 }
842 # }}}
843
844 # {{{ automount(er)
845 config_automounter(){
846 if checkbootparam automounter ; then
847   RUNLEVEL="$(runlevel)"
848   AUTOMOUNTER=""
849   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
850
851 addautomount(){
852 # /dev/ice  options
853   d="${1##*/}"
854   if [ -n "$AUTOMOUNTER" ]; then
855     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
856     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
857     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
858     anew="$d        -fstype=auto,$2 :$i"
859     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
860     AUTOMOUNTS="$AUTOMOUNTS $d"
861     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
862   else
863     [ -d /mnt/$d ] && mkdir -p /mnt/$d
864     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
865   fi
866   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
867 }
868
869   AUTOMOUNTS="floppy cdrom"
870 # Add new devices to /etc/fstab and /etc/auto.mnt
871   for i in /dev/cdrom?*; do
872     if [ -L $i ]; then
873       addautomount "$i" "ro"
874     fi
875   done
876 fi
877
878 if [ -n "$AUTOMOUNTER" ]; then
879 # Check for floppy dir, reinstall with automounter
880   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
881   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
882   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
883   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
884   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
885   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
886   rm -f /etc/fstab.new
887 # Replace paths from bootfloppy
888   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
889   mv -f /etc/fstab.new /etc/fstab
890 # Start automounter now
891   einfo "Starting automounter for ${AUTOMOUNTS}."
892   /etc/init.d/autofs start >>$DEBUG ; eend $?
893 fi
894 }
895 # }}}
896
897 # {{{ Collect partitions from /proc/partitions first for enabling DMA
898 check_partitions(){
899 partitions=""
900 IDEDISKS=""
901 while read major minor blocks partition relax; do
902   partition="${partition##*/}"
903   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
904   case "$partition" in
905     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
906     sd?) ;;                                               # SCSI Harddisk, entire disk
907 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
908     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
909   esac
910 done <<EOT
911 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
912 EOT
913 }
914 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
915 # }}}
916
917 # {{{ Enable DMA for all IDE drives now if not disabled
918 # Notice: Already done by linuxrc, maybe not on hd-installations
919 config_dma(){
920 if checkbootparam "nodma"; then
921   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
922 else
923   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
924     if test -d /proc/ide/$d; then
925       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
926         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
927         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
928         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
929         echo "using_dma:1" >/proc/ide/$d/settings
930         eend 0
931       fi
932     fi
933   done
934 fi
935 }
936 # }}}
937
938 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
939 config_fstab(){
940 NOSWAP=""
941 checkbootparam "noswap" && NOSWAP="yes"
942 if checkbootparam "nofstab"; then
943   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
944 else
945   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
946   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
947   iszsh && setopt nonomatch
948   if [ -x /usr/sbin/rebuildfstab ] ; then
949     config_userfstab || fstabuser=grml
950     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
951   else
952     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
953   fi
954   if [ -e /var/run/rebuildfstab.pid ]; then
955     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
956     sleep 8
957   fi
958 fi
959 # Scan for swap, config, homedir
960 if [ -z "$NOSWAP" -o -z "$INSTALLED" ]; then
961   einfo "Checking for swap partition(s)."
962 fi
963 GRML_IMG=""
964 GRML_SWP=""
965 HOMEDIR="$(getbootparam home)"
966 if [ -n "$partitions" ]; then
967  while read p m f relax; do
968   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
969   partoptions="users,exec"
970   fnew=""
971   case "$f" in swap)
972    eindent
973    if [ -n "$NOSWAP" ]; then
974     ewarn "Ignoring swap partition ${WHITE}$p${NORMAL} as requested." ; eend 0
975    else
976      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
977              S1SUSP|S2SUSP|pmdisk|[zZ]*)
978                 if [ -n "$ANYSWAP" ] ; then
979                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
980                   swapon $p 2>>$DEBUG ; eend $?
981                 else
982                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
983                 fi
984                ;;
985              *)
986                 if [[ "$p" == LABEL* ]] ; then
987                    p=$(blkid -t $p | awk -F: '{print $1}')
988                 fi
989                 if grep -q $p /proc/swaps ; then
990                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
991                 else
992                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
993                    swapon $p 2>>$DEBUG ; eend $?
994                 fi
995                ;;
996      esac
997    fi
998    eoutdent
999    continue
1000    ;;
1001   esac
1002 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
1003 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
1004 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
1005 #  [ -d "$m" ] || mkdir -p "$m"
1006 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1007   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1008   MOUNTOPTS="ro"
1009   case "$f" in
1010     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1011     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1012     *) continue ;;
1013     # *) NONEFOUND='1'; continue ;;
1014   esac
1015   mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1016   # Activate swapfile, if exists
1017   SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1018   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1019    mount -o remount,rw $m
1020    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1021     einfo "Using GRML swapfile ${SWAPFILE}."
1022     fnew="$SWAPFILE swap swap defaults 0 0"
1023     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1024     GRML_SWP="$GRML_SWP $SWAPFILE"
1025     eend 0
1026    fi
1027    mount -o remount,ro $m 2>>$DEBUG
1028   fi
1029   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1030   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1031    if [ -n "$HOMEDIR" ]; then
1032     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1033      continue
1034     fi
1035    fi
1036    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1037     GRML_IMG="$IMAGE"
1038     mount -o remount,ro $m 2>>$DEBUG
1039    fi
1040   fi
1041   eend 0
1042   # Umount, if not in use
1043   umount -r $m 2>/dev/null
1044  done <<EOT
1045 $(cat /etc/fstab)
1046 EOT
1047 fi
1048 }
1049 # }}}
1050
1051 # {{{ Mouse
1052 config_mouse(){
1053 if [ -n "$MOUSE_DEVICE" ] ; then
1054   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1055 fi
1056 }
1057 # }}}
1058
1059 # {{{ IPv6 configuration
1060 # Load IPv6 kernel module and print IP adresses
1061 config_ipv6(){
1062 if checkbootparam "ipv6"; then
1063   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1064   modprobe ipv6
1065   # we probably need some time until stateless autoconfiguration has happened
1066   sleep 2
1067   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1068   for DEVICE in `echo "$NETDEVICES"`
1069   do
1070     eindent
1071     einfo "$DEVICE:"
1072     ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1073     COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1074     eindent
1075     for ADDR in `echo "$ADDRESSES"`
1076     do
1077       einfo "$ADDR"
1078     done
1079     if [ "$COUNT" -eq "0" ]
1080     then
1081       einfo "(none)" ; eend 1
1082     fi
1083     eoutdent
1084     eoutdent
1085   done
1086   eend 0
1087 fi
1088 }
1089 # }}}
1090
1091 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1092 config_dhcp(){
1093 if checkbootparam "nodhcp"; then
1094   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1095 else
1096   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1097   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1098   for DEVICE in `echo "$NETDEVICES"` ; do
1099     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1100     trap 2 3 11
1101     ifconfig $DEVICE up >>$DEBUG 2>&1
1102     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1103     trap "" 2 3 11
1104     sleep 1
1105     eend 0
1106   done
1107 fi
1108 }
1109 # }}}
1110
1111 # {{{ helper functions
1112 findfile(){
1113 FOUND=""
1114 # search all partitions for a file in the root directory
1115 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1116 # See if it's already mounted
1117   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1118   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1119     [ -f "$i/$1" ] && FOUND="$i/$1"
1120     umount -l "$i" 2>>$DEBUG
1121     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1122   fi
1123 done
1124 return 2
1125 }
1126
1127 fstype(){
1128 case "$(file -s $1)" in
1129   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1130   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1131   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1132   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1133   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1134   *data*)          echo "invalid"; return 0;;
1135   *) echo "auto"; return 0;;
1136 esac
1137 }
1138
1139 # Try to mount this filesystem read-only, without or with encryption
1140 trymount(){
1141 # Check if already mounted
1142 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1143 # Apparently, mount-aes DOES autodetect AES loopback files.
1144 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1145 # We need to mount crypto-loop files with initial rw support
1146 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1147 # Mount succeeded?
1148 [ "$RC" = "0" ] && return 0
1149 echo ""
1150 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1151 a="y"
1152 while [ "$a" != "n" -a "$a" != "N" ]; do
1153 # We need to mount crypto-loop files with initial rw support
1154  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1155  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1156  # Problem with ioctl() from getpasswd()?
1157  # read a
1158  read a
1159 done
1160 return 1
1161 }
1162 # }}}
1163
1164 # {{{ CPU-detection
1165 config_cpu(){
1166 if checkbootparam "nocpu"; then
1167   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1168 else
1169   if ! [ -x /etc/init.d/powernowd ] ; then
1170     ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
1171   elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
1172     ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
1173   else
1174     einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1175     if /usr/sbin/laptop-detect ; then
1176     einfo "Detected Laptop - trying to use cpu frequency scaling:"
1177 #      loadcpumod() {
1178 #      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
1179 #    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
1180 #        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
1181 #      done
1182 #      }
1183 #    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
1184 #    eindent
1185 #    if [[ $CPU = *Intel* ]] ; then
1186 #      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
1187 #      local DETECTED=1
1188 #      loadcpumod
1189 #      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
1190 #    fi
1191 #    if [[ $CPU = *AMD* ]] ; then
1192 #      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
1193 #      local DETECTED=1
1194 #      loadcpumod
1195 #      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1196 #    fi
1197
1198      eindent
1199      if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1200        . /usr/bin/cpufreq-detect.sh
1201        if [ -n "$MODULE" -a "$MODULE" != none ]; then
1202          einfo "Loading module ${MODULE} and starting powernowd."
1203          modprobe cpufreq_userspace 1>>$DEBUG
1204          modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1205          /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1206        else
1207          ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
1208        fi
1209      fi
1210      eoutdent
1211    fi
1212   fi
1213 fi
1214 }
1215 # }}}
1216
1217 # {{{ autostart of ssh
1218 config_ssh(){
1219 if checkbootparam ssh ; then
1220   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1221   einfo "Bootoption passwd found."
1222   if [ -n "$SSH_PASSWD" ] ; then
1223     echo "grml:$SSH_PASSWD" | chpasswd -m
1224     einfo "Starting secure shell server in background."
1225     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1226     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1227     eend 0
1228   else
1229     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1230   fi
1231   eindent
1232     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1233   eoutdent
1234 fi
1235 }
1236 # }}}
1237
1238 # {{{ set password for user grml
1239 config_passwd(){
1240 if checkbootparam passwd >>$DEBUG 2>&1; then
1241   einfo "Bootoption passwd found."
1242   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1243   if [ -n "$PASSWD" ] ; then
1244     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1245   else
1246     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1247   fi
1248   eindent
1249     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1250   eoutdent
1251 fi
1252 }
1253 # }}}
1254
1255 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1256 config_homedir(){
1257 HOMEDIR="$(getbootparam home)"
1258 MYHOMEDEVICE=""
1259 MYHOMEMOUNTPOINT=""
1260 MYHOMEDIR=""
1261 if [ -n "$HOMEDIR" ]; then
1262   einfo "Bootoption home detected." && eend 0
1263   case "$HOMEDIR" in
1264     /dev/*)
1265     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1266     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1267     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1268     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1269   ;;
1270     /mnt/*)
1271     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1272     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1273     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1274     MYHOMEDIR="$HOMEDIR"
1275   ;;
1276     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1277     MYHOMEDIR="$(findfile grml.img)"
1278     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1279     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1280     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1281   ;;
1282   *)
1283     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1284     eerror "Option ignored." ; eend 1
1285   ;;
1286   esac
1287 fi
1288
1289 if [ -n "$MYHOMEDIR" ]; then
1290   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1291     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1292     while read device mountpoint fs relax; do
1293       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1294         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1295           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1296           break
1297         ;;
1298         *[Ff][Aa][Tt]*)
1299         # Note: This currently won't work with encrypted partitions
1300         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1301         if [ ! -f "$MYHOMEDIR" ]; then
1302           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1303           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1304         fi
1305         ;;
1306       esac
1307       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1308         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1309         if [ -f "$MYHOMEDIR" ]; then
1310           # It's a loopback file, mount it over the /home/grml directory
1311           trymount "$MYHOMEDIR" /home/grml
1312           RC="$?"
1313           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1314           RC="$?"
1315         else
1316           # Do a --bind mount
1317           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1318           RC="$?"
1319         fi
1320         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1321       fi
1322       break
1323       ;;
1324     esac
1325   done <<EOT
1326 $(cat /proc/mounts)
1327 EOT
1328   fi
1329 fi
1330 }
1331 # }}}
1332
1333 # {{{ Check if we want the config floppy
1334 config_old_myconfig(){
1335 MYCONF=""
1336 case "$CMDLINE" in *\ myconfig*) MYCONF="yes"; ;; esac
1337 if [ -n "$MYCONF" ]; then
1338   einfo "Bootoption myconfig detected." && eend 0
1339 # Check for given config directory
1340   MYCONFDIR="$(getbootparam 'myconfig')"
1341   [ -n "$MYCONFDIR" ] || MYCONFDIR="$(getbootparam 'myconfig')"
1342 fi
1343
1344 # Check for configuration floppy add-on if not running from HD
1345 if [ -z "$INSTALLED" -a -n "$MYCONF" ]; then
1346   FOUND_CONFIG=""
1347   if [ -n "$MYCONFDIR" ]; then
1348     case "$MYCONFDIR" in
1349      /dev/*)
1350        MYCONFDEVICE="${MYCONFDIR##/dev/}"
1351        MYCONFDEVICE="/dev/${MYCONFDEVICE%%/*}"
1352        MYCONFMOUNTPOINT="/mnt/${MYCONFDEVICE##/dev/}"
1353        MYCONFDIR="/mnt/${MYCONFDIR##/dev/}"
1354       ;;
1355      /mnt/*)
1356        MYCONFDEVICE="${MYCONFDIR##/mnt/}"
1357        MYCONFDEVICE="/dev/${MYCONFDEVICE%%/*}"
1358        MYCONFMOUNTPOINT="/mnt/${MYCONFDEVICE##/dev/}"
1359       ;;
1360      [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1361        MYCONFDIR="$(findfile grml.sh)"
1362        if [ -n "$MYCONFDIR" ]; then
1363          MYCONFDEVICE="${MYCONFDIR##/mnt/}"
1364          MYCONFDEVICE="/dev/${MYCONFDEVICE%%/*}"
1365          MYCONFMOUNTPOINT="/mnt/${MYCONFDEVICE##/dev/}"
1366          MYCONFDIR="${MYCONFMOUNTPOINT}"
1367        else
1368          FOUND_CONFIG="none"
1369        fi
1370       ;;
1371      *)
1372        eerror "Invalid configdir '$MYCONFDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1373        eerror "Option ignored."
1374        FOUND_CONFIG="invalid"
1375       ;;
1376     esac
1377   else
1378     MYCONFDEVICE="/dev/fd0"
1379     MYCONFMOUNTPOINT="/mnt/floppy"
1380     MYCONFDIR="/mnt/floppy"
1381   fi
1382
1383   eindent
1384   if [ -z "$FOUND_CONFIG" ]; then
1385     einfo "Checking ${WHITE}${MYCONFDIR}${NORMAL} for grml configuration files...${NORMAL}"
1386     [ -d $MYCONFMOUNTPOINT ] || mkdir $MYCONFMOUNTPOINT && chown grml: $MYCONFMOUNTPOINT
1387     if trymount "$MYCONFDEVICE" "$MYCONFMOUNTPOINT"; then
1388       MYCONFIG="$(/bin/ls -1d $MYCONFDIR/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1389       if [ -n "$MYCONFIG" -a -f "$MYCONFIG" ]; then
1390         echo ""
1391         FOUND_CONFIG="yes"
1392         einfo "Found, now executing ${WHITE}${MYCONFIG}${NORMAL}."
1393         echo "6" > /proc/sys/kernel/printk
1394         . "$MYCONFIG" "$MYCONFDIR" || true
1395         echo "0" > /proc/sys/kernel/printk
1396       fi
1397       umount "$MYCONFMOUNTPOINT" 2>>$DEBUG
1398     fi
1399   fi
1400   [ -n "$FOUND_CONFIG" ] || eerror "Not present."
1401   eoutdent
1402 fi
1403 # }}}
1404
1405 # {{{ Check for extra shellscript on CD-ROM (/cdrom/GRML/grml.sh)
1406 MYCONFIG="$(/bin/ls -1d /cdrom/GRML/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1407 if [ -n "$MYCONFIG" -a -f "$MYCONFIG" ]; then
1408   echo ""
1409   FOUND_CONFIG="yes"
1410   einfo "grml script/configuration file found on CD, executing ${BLUE}${MYCONFIG}${NORMAL}:"
1411   echo "6" > /proc/sys/kernel/printk
1412   . "$MYCONFIG" /cdrom/GRML || true
1413   echo "0" > /proc/sys/kernel/printk
1414 fi
1415 }
1416 # }}}
1417
1418 # {{{ Check for scripts on CD-ROM
1419 config_cdrom_scripts(){
1420 if checkbootparam "script"; then
1421   for script in /cdrom/scripts/* ; do
1422     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1423     . $script
1424   done
1425 fi
1426 }
1427 # }}}
1428
1429 # {{{ Sound
1430 config_mixer(){
1431 if ! [ -x /usr/bin/aumix ] ; then
1432   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1433 else
1434
1435   if checkbootparam vol ; then
1436     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1437     if [ -z "$VOL" ] ; then
1438       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1439       VOL='75' # default
1440     fi
1441   else
1442     VOL='75' # default
1443   fi
1444
1445   if checkbootparam nosound ; then
1446     einfo "Muting sound devices on request."
1447     # some IBM notebooks require the following stuff:
1448     if [ -x /usr/bin/amixer ] ; then
1449        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1450           amixer set Front unmute 1>/dev/null
1451           amixer set Front 0% 1>/dev/null
1452        fi
1453     fi
1454     aumix -w 0 -v 0 -p 0 -m 0 ; eend $?
1455   elif [ -z "$INSTALLED" ]; then
1456       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1457       # some IBM notebooks require the following stuff:
1458       if [ -x /usr/bin/amixer ] ; then
1459          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1460             amixer set Front unmute 1>/dev/null
1461             amixer set Front ${VOL}% 1>/dev/null
1462          fi
1463       fi
1464       aumix -w $VOL -v $VOL -p $VOL -m $VOL ; eend $?
1465   fi
1466
1467 fi
1468 }
1469 # }}}
1470
1471 # {{{ modem detection
1472 config_modem(){
1473 if checkbootparam "nomodem"; then
1474   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1475 else
1476   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1477    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1478      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1479      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1480      eend 0
1481    fi
1482   fi
1483 fi
1484 }
1485 # }}}
1486
1487 # {{{ keyboard add-ons
1488 config_setkeycodes(){
1489 if checkbootparam "setkeycodes" ; then
1490  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1491   # MS MM keyboard add-on
1492   # fix
1493   setkeycodes e001 126 &>/dev/null
1494   setkeycodes e059 127 &>/dev/null
1495   # fn keys
1496   setkeycodes e03b 59 &>/dev/null
1497   setkeycodes e008 60 &>/dev/null
1498   setkeycodes e007 61 &>/dev/null
1499   setkeycodes e03e 62 &>/dev/null
1500   setkeycodes e03f 63 &>/dev/null
1501   setkeycodes e040 64 &>/dev/null
1502   setkeycodes e041 65 &>/dev/null
1503   setkeycodes e042 66 &>/dev/null
1504   setkeycodes e043 67 &>/dev/null
1505   setkeycodes e023 68 &>/dev/null
1506   setkeycodes e057 87 &>/dev/null
1507   setkeycodes e058 88 &>/dev/null
1508   # hp keycodes
1509   setkeycodes e00a 89 e008 90 &>/dev/null
1510  eend 0
1511 fi
1512 }
1513 # }}}
1514
1515 # {{{ wondershaper
1516 config_wondershaper(){
1517  if checkbootparam "wondershaper" ; then
1518     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1519     CMD=wondershaper
1520     DEVICE=""
1521     DOWNSTREAM=""
1522     UPSTREAM=""
1523     if [ -n "$WONDER" ]; then
1524       # Extra options
1525       DEVICE="${WONDER%%,*}"
1526       R="${WONDER#*,}"
1527       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1528         WONDER="$R"
1529         DOWNSTREAM="${WONDER%%,*}"
1530         R="${WONDER#*,}"
1531         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1532           WONDER="$R"
1533           UPSTREAM="${WONDER%%,*}"
1534           R="${WONDER#*,}"
1535         fi
1536       fi
1537     fi
1538     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1539     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1540     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1541     einfo "Starting wondershaper (${CMD}) in background."
1542     ( sh -c $CMD & ) && eend 0
1543  fi
1544 }
1545 # }}}
1546
1547 # {{{ syslog-ng
1548 config_syslog(){
1549  if checkbootparam "nosyslog"; then
1550   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1551  else
1552   einfo "Starting syslog-ng in background."
1553   /etc/init.d/syslog-ng start 1>>$DEBUG &
1554   eend 0
1555  fi
1556 }
1557 # }}}
1558
1559 # {{{ gpm
1560 config_gpm(){
1561  if checkbootparam "nogpm"; then
1562   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1563  else
1564   einfo "Starting gpm in background."
1565 #  /etc/init.d/gpm start 1>>$DEBUG &
1566   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1567   eend 0
1568  fi
1569 }
1570 # }}}
1571
1572 # {{{ services
1573 config_services(){
1574  if checkbootparam "services" ; then
1575     SERVICE="$(getbootparam services 2>>$DEBUG)"
1576     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1577     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1578     einfo "Starting service(s) ${SERVICENL} in background."
1579     for service in $(echo -e $SERVICELIST) ; do
1580        /etc/init.d/${service} start 1>>$DEBUG &
1581     done
1582     [ "$?" == "0" ] ; eend $?
1583  fi
1584 }
1585 # }}}
1586
1587 # {{{ config files
1588 config_netconfig(){
1589  if checkbootparam netconfig ; then
1590   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1591   CONFIGFILE='/tmp/netconfig.grml'
1592
1593   getconfig() {
1594   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1595        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1596   }
1597   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1598   counter=10
1599   while ! getconfig && [[ "$counter" != 0 ]] ; do
1600     echo -n "Sleeping for 5 seconds and trying to get config again... "
1601     counter=$(( counter-1 ))
1602     echo "$counter tries left" ; sleep 1
1603   done
1604   if [ -r "$CONFIGFILE" ] ; then
1605     einfo "Downloading was successfull." ; eend 0
1606     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1607     md5sum $CONFIGFILE ; eend 0
1608     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1609   else
1610     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1611   fi
1612  fi
1613 }
1614 # }}}
1615
1616 # {{{ blindsound
1617 config_blindsound(){
1618  if checkbootparam "blind" ; then
1619     beep
1620     flite -o play -t "welcome to the gremel system"
1621  fi
1622 }
1623 # }}}
1624
1625 # {{{ welcome sound
1626 config_welcome(){
1627  if checkbootparam welcome ; then
1628   flite -o play -t "welcome to the gremel system"
1629  fi
1630 }
1631 # }}}
1632
1633 # {{{ fix/workaround for unionfs
1634 fix_unionfs(){
1635   if [ -z "$INSTALLED" ]; then
1636    touch /var/cache/apt/*cache.bin
1637   fi
1638 }
1639 # }}}
1640
1641 # {{{ create all /mnt-directories
1642 create_mnt_dirs(){
1643   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1644   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1645 }
1646 # }}}
1647
1648 # {{{ start X window system via grml-x
1649 config_x_startup(){
1650 if checkbootparam startx ; then
1651  if [ -x /usr/X11R6/bin/X ] ; then
1652   if [ -z "$INSTALLED" ] ; then
1653    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1654    if [ -z "$WINDOWMANAGER" ] ; then
1655      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1656      WINDOWMANAGER="wm-ng"
1657    else
1658      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1659    fi
1660    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1661    config_userfstab || fstabuser='grml'
1662  cat>|/etc/init.d/xstartup<<EOF
1663 #!/bin/sh
1664 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1665 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1666 EOF
1667    chmod 755 /etc/init.d/xstartup
1668    sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1669    sed -i 's#^6.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#'   /etc/inittab
1670    /sbin/telinit q ; eend $?
1671   else
1672     eerror "We are not running from CD - startx will not work, skipping it.
1673      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1674   fi
1675  else
1676    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1677    Boot parameter startx does not work therefore." ; eend 1
1678  fi
1679 fi
1680 }
1681 # }}}
1682
1683 # {{{ configuration framework
1684 config_extract(){
1685 if checkbootparam extract ; then
1686  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1687  EXTRACTOPTIONS="-- -x $EXTRACT"
1688 fi
1689 }
1690
1691 config_automount(){
1692 if checkbootparam noautoconfig ; then
1693   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1694 else
1695  if [ -z "$INSTALLED" ] ; then
1696   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1697   eindent
1698   [ -d /mnt/grml ] || mkdir /mnt/grml
1699   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1700 # We do need the following fix so floppy disk is available to blkid in any case :-/
1701   if [ -r /dev/fd0 ] ; then
1702      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1703 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1704      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1705         blkid /dev/fd0 1>>$DEBUG 2>&1
1706      fi
1707   fi
1708   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1709   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1710   if [[ $RC == 0 ]]; then
1711     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1712
1713     CONFIG=''
1714     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1715     if [ -n "$CONFIG" ]; then
1716       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1717       cd /
1718       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1719     else
1720       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1721     fi
1722
1723     SCRIPT=''
1724     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1725     if [ -n "$SCRIPT" ]; then
1726       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1727       $SCRIPT ; eend $?
1728     fi
1729     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1730   else
1731     ewarn "No devices with label GRMLCFG found." ; eend 0
1732   fi
1733   eoutdent
1734  fi
1735 fi
1736 }
1737
1738 config_myconfig(){
1739 if checkbootparam myconfig ; then
1740  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1741  if [ -n "$MOUNTDEVICE" ]; then
1742    if checkbootparam file ; then
1743     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1744     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1745    fi
1746    [ -d /mnt/grml ] || mkdir /mnt/grml
1747    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1748    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1749     if [[ $RC == 0 ]]; then
1750       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1751       eindent
1752       CONFIG=''
1753       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1754       if [ -n "$CONFIG" ]; then
1755         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1756         cd /
1757         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1758       else
1759         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1760       fi
1761
1762       SCRIPT=''
1763       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1764       if [ -n "$SCRIPT" ]; then
1765         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1766         $SCRIPT ; eend $?
1767       fi
1768       eoutdent
1769     else
1770       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1771     fi # mount $MOUNTDEVICE
1772    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1773  else
1774    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1775  fi # [ -n "$MOUNTDEVICE" ]
1776 fi # checkbootparam myconfig
1777
1778 if checkbootparam "partconf" ; then
1779  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1780  if [ -n "$MOUNTDEVICE" ]; then
1781    [ -d /mnt/grml ] || mkdir /mnt/grml
1782    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1783     if [[ $RC == 0 ]]; then
1784       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1785       einfo "Copying files from $MOUNTDEVICE over grml system."
1786       for file in `cat /etc/grml/partconf` ; do
1787         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1788         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1789       done && eend 0
1790     else
1791       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1792     fi # mount $MOUNTDEVICE
1793    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1794  else
1795    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1796  fi # [ -n "$MOUNTDEVICE" ]
1797 fi
1798 }
1799 # }}}
1800
1801 # {{{ /cdrom/.*-options
1802 config_debs(){
1803 if checkbootparam "debs" ; then
1804   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1805   [ -z "$CONFIG" ] && CONFIG="/cdrom/debs/*"
1806   einfo "Tring to install debian package(s) ${DEBS}:"
1807   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1808 fi
1809 }
1810
1811 config_config(){
1812 if checkbootparam "config" ; then
1813   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1814   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1815   einfo "Bootoption config found. config is set to: $CONFIG"
1816   eindent
1817     einfo "Trying to extract configuration file ${CONFIG}:"
1818     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1819   eoutdent
1820 fi
1821 }
1822
1823 config_scripts(){
1824 if checkbootparam "scripts" ; then
1825   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1826   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1827   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1828   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1829 fi
1830 }
1831 # }}}
1832
1833 # {{{ distcc
1834 config_distcc(){
1835 if checkbootparam "distcc" ; then
1836  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1837  if [ -n "$OPTIONS" ]; then
1838     NET=""
1839     INTERFACE=""
1840     if [ -n "$OPTIONS" ]; then
1841       NET="${OPTIONS%%,*}"
1842       R="${OPTIONS#*,}"
1843       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1844         OPTIONS="$R"
1845         INTERFACE="${OPTIONS%%,*}"
1846         R="${OPTIONS#*,}"
1847       fi
1848     fi
1849  fi
1850  CONFIG=/etc/default/distcc
1851  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1852  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1853
1854  if [ -n "$INTERFACE" ] ; then
1855    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1856
1857    counter=10
1858    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1859      counter=$(( counter-1 ))
1860      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1861      sleep 3
1862      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1863    done
1864  fi
1865
1866  if [ -n "$IP" ] ; then
1867    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1868
1869    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1870    eindent
1871     id distccd >/dev/null 2>&1 || \
1872     (
1873       einfo "Creating distcc user" ; \
1874       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1875     )
1876
1877     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1878    /etc/init.d/distcc start 1>/dev/null ; eend $?
1879    eoutdent
1880  else
1881    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1882  fi
1883 fi
1884
1885 if checkbootparam "gcc"; then
1886  GCC="$(getbootparam gcc 2>>$DEBUG)"
1887  eindent
1888  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1889  eoutdent
1890  rm -f /usr/bin/gcc
1891  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1892 fi
1893
1894 if checkbootparam "gpp"; then
1895  GPP="$(getbootparam gpp 2>>$DEBUG)"
1896  eindent
1897   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1898   if [ -x /usr/bin/g++-${GPP} ] ; then
1899      rm -f /usr/bin/g++
1900      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1901   fi
1902   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1903   if [ -x /usr/bin/cpp-${GPP} ] ; then
1904      rm -f /usr/bin/cpp
1905      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1906   fi
1907  eoutdent
1908 fi
1909
1910 }
1911 # }}}
1912
1913 # {{{ load modules
1914 # Notice: use it only on live-cd system, if running from harddisk please
1915 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1916 # in /etc/runlevel.conf
1917 config_modules(){
1918 MODULES_FILE=/etc/grml/modules
1919 if checkbootparam nomodules ; then
1920   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1921 elif [ -z "$INSTALLED" ]; then
1922  if [ -r $MODULES_FILE ] ; then
1923   einfo "Loading modules specified in ${MODULES_FILE}:"
1924   eindent
1925   grep '^[^#]' $MODULES_FILE | \
1926   while read module args; do
1927     [ "$module" ] || continue
1928       einfo "${module}"
1929       modprobe $module $args ; eend $?
1930   done
1931   eoutdent
1932  else
1933   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1934  fi
1935 fi
1936 }
1937 # }}}
1938
1939 # {{{ 915resolution
1940 config_915resolution(){
1941 if checkbootparam "915resolution" ; then
1942  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1943   if [ -x /usr/sbin/915resolution ]; then
1944     CMD=915resolution
1945     MODE=""
1946     XRESO=""
1947     YRESO=""
1948     if [ -n "$OPTIONS" ]; then
1949       # Extra options
1950       MODE="${OPTIONS%%,*}"
1951       R="${OPTIONS#*,}"
1952       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1953         OPTIONS="$R"
1954         XRESO="${OPTIONS%%,*}"
1955         R="${OPTIONS#*,}"
1956         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1957           OPTIONS="$R"
1958           YRESO="${OPTIONS%%,*}"
1959           R="${OPTIONS#*,}"
1960         fi
1961       fi
1962     fi
1963     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1964     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1965     eend 0
1966   fi
1967 fi
1968 }
1969 # }}}
1970
1971 # {{{ debnet: setup network based on an existing one found on a partition
1972 config_debnet(){
1973 if checkbootparam "debnet" ; then
1974  iszsh && setopt shwordsplit
1975  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
1976  DEVICES="$DEVICES $(ls /dev/mapper/*)"
1977  FOUND_DEBNET=""
1978
1979  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
1980  eindent
1981  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
1982     for i in $DEVICES; do
1983      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
1984          einfo "Scanning on $i"
1985        if [ -f /mnt/etc/network/interfaces ]; then
1986          einfo "/etc/network/interfaces found on ${i}" ; eend 0
1987          FOUND_DEBNET="$i"
1988          break
1989        fi
1990        umount /mnt
1991      fi
1992     done
1993
1994    if [ -n "$FOUND_DEBNET" ]; then
1995      einfo "Stopping network."
1996        pump -k 1>/dev/null 2>&1
1997        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
1998      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
1999        rm -rf /etc/network/run
2000        cp -a /mnt/etc/network /etc
2001        rm -rf /etc/network/run
2002        mkdir /etc/network/run
2003        umount /mnt ; eend $?
2004      einfo "Starting network."
2005        /etc/init.d/networking start ; eend $?
2006    else
2007      eerror "/etc/network/interfaces not found." ; eend 1
2008    fi
2009    eoutdent
2010  else
2011   eerror "Error: /mnt already mounted." ; eend 1
2012  fi
2013 fi
2014 }
2015 # }}}
2016
2017 # {{{ disable console blanking
2018 config_blanking(){
2019 if checkbootparam "noblank" ; then
2020   einfo "Bootoption noblank found. Disabling monitor blanking."
2021   setterm -blank 0 ; eend $?
2022 fi
2023 }
2024 # }}}
2025
2026 # {{{ grml2hd: automatic installation
2027 config_grml2hd(){
2028
2029 if checkbootparam "user" ; then
2030   NEWUSER=''
2031   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2032   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2033 fi
2034
2035 if checkbootparam "filesystem" ; then
2036   FILESYSTEM=''
2037   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2038   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2039 fi
2040
2041 if checkbootparam "partition" ; then
2042   PARTITION=''
2043   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2044   # notice: the following checks whether the given partition is available, if not the skip
2045   # execution of grml2hd as it might result in data loss...
2046   if [ -r $PARTITION ] ; then
2047     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2048   else
2049     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2050   fi
2051 fi
2052
2053 if checkbootparam "mbr" ; then
2054   BOOT_PARTITION=''
2055   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2056   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2057 fi
2058
2059 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2060   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2061 #!/bin/sh
2062 GRML2HD_NONINTERACTIVE='yes' grml2hd
2063 EOF
2064   chmod 755 /usr/bin/grml2hd_noninteractive
2065   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2066   if [ -z "$GRML2HD_FAIL" ] ; then
2067     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2068   else
2069     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2070   fi
2071 fi
2072 }
2073 # }}}
2074
2075 ### {{{ backwards compatible stuff
2076 config_environment(){
2077   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2078 }
2079 config_running_from() {
2080   ewarn "config_running_from is deprecated. Please set CONFIG_RUNNING_FROM in /etc/grml/autoconfig to 'no'." ; eend 0
2081 }
2082 config_keyboard(){
2083   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2084 }
2085 # }}}
2086
2087 ## END OF FILE #################################################################
2088 # vim:foldmethod=marker